/*

*/
package scene.models2;
import scene.*;
import scene.primitives.*;

import java.awt.Color;

/**
   A flat checkerboard in the xz-plane.
*/
public class PanelModel extends Model
{
   public PanelModel( )
   {
      this(-1, 1, -1, 1);
   }


   public PanelModel(int xMin, int xMax, int zMin, int zMax)
   {
      super();

      // Create the line segments that run in the z-direction.
      for (int x = xMin; x <= xMax; x++)
      {
         Primitive ls = new LineSegment(new Vertex(x, 0, zMin),
                                        new Vertex(x, 0, zMax));
         this.addPrimitive( ls );
      }

      // Create the line segments that run in the x-direction.
      for (int z = zMin; z <= zMax; z++)
      {
         Primitive ls = new LineSegment(new Vertex(xMin, 0, z),
                                        new Vertex(xMax, 0, z));
         this.addPrimitive( ls );
      }
   }
}