/*

*/
package scene.models2;
import scene.*;
import scene.primitives.*;

import java.awt.Color;

/**
   A flat checkerboard in the xz-plane.
*/
public class PanelModel_v2 extends Model
{
   public PanelModel_v2( )
   {
      this(-1, 1, -1, 1);
   }


   public PanelModel_v2(int xMin, int xMax, int zMin, int zMax)
   {
      super();

      // Create the checkerboard's geometry.
      Vertex[][] v = new Vertex[(xMax-xMin)+1][(zMax-zMin)+1];

      for (int x = xMin; x <= xMax; x++)
         for (int z = zMin; z <= zMax; z++)
         {
            v[x-xMin][z-zMin] = new Vertex(x, 0, z);
         }

      // Create the line strips that run in the z-direction.
      for (int x = 0; x <= xMax-xMin; x++)
      {
         Primitive ls = new LineStrip();
         for (int z = 0; z <= zMax-zMin; z++)
         {
            ls.addVertex( v[x][z] );
         }
         this.addPrimitive( ls );
      }

      // Create the line strips that run in the x-direction.
      for (int z = 0; z <= zMax-zMin; z++)
      {
         Primitive ls = new LineStrip();
         for (int x = 0; x <= xMax-zMin; x++)
         {
            ls.addVertex( v[x][z] );
         }
         this.addPrimitive( ls );
      }
   }
}