/*

*/
package scene.models3;
import scene.*;
import scene.primitives.*;

import java.awt.Color;

/**
   A flat checkerboard panel in the xz-plane.
*/
public class PanelModel extends Model
{
   public PanelModel( )
   {
      this(-1, 1, -1, 1);
   }


   public PanelModel(int xMin, int xMax, int zMin, int zMax)
   {
      super();

      // Create the checkerboard panel's geometry.

      // An array of vertices to be used to create primitives.
      Vertex[][] v = new Vertex[(xMax-xMin)+1][(zMax-zMin)+1];

      // Create the checkerboard of vertices.
      for (int x = xMin; x <= xMax; x++)
         for (int z = zMin; z <= zMax; z++)
         {
            v[x-xMin][z-zMin] = new Vertex(x, 0, z);
         }

      // Create the checkerboard faces.
      for (int x = 0; x < xMax-xMin; x++)
      {
         for (int z = 0; z < zMax-zMin; z++)
         {
            Primitive face = new Face();
            face.addVertex( v[x][z+1] );
            face.addVertex( v[x+1][z+1] );
            face.addVertex( v[x+1][z] );
            face.addVertex( v[x][z] );
            this.addPrimitive( face );
         }
      }
   }
}